/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 16 mai 2007
   derniere modification : 20/10/2007 */

#ifndef SCEMODEL_H__
#define SCEMODEL_H__

#include <SCE/interface/SCEMaterial.h>
#include <SCE/interface/SCEMesh.h>


typedef struct sce_smodel SCE_SModel;
struct sce_smodel
{
    SCE_SMesh **meshs;  /* maillage du modele (tableau de lod) */
    unsigned int lod;   /* LOD courant */
    SCE_SMaterial *mat; /* materiau du modele */
    int cullface;
};


/* initialise le gestionnaire de modeles */
int SCE_Init_Model (void);
/* quitte le gestionnaire de modeles */
void SCE_Quit_Model (void);

/* cree un modele */
SCE_SModel* SCE_Model_Create (void);
/* supprime un modele */
void SCE_Model_Delete (SCE_SModel*);

/* bind le modele entier */
void SCE_Model_Bind (SCE_SModel*);
/* bind le mesh du modele */
void SCE_Model_BindMesh (SCE_SModel*);
/* bind le materiau du modele */
void SCE_Model_BindMaterial (SCE_SModel*);
/* dessine le modele binde */
void SCE_Model_Draw (void);
/* effectue le rendu d'un modele */
void SCE_Model_Render (SCE_SModel*);

/* charge un mesh */
int SCE_Model_LoadMesh (SCE_SModel*, const char*);

#endif /* guard */
